# ARST打卡第318周

<!--more-->

## Algorithm
lc386_字典序排数

思路:

按字典序排出不大于n的数字，从1开始。

取出各位置上的数字，后续在最大的时候停止。

```rust
impl Solution {
    pub fn lexical_order(n: i32) -> Vec<i32> {
        let mut result = Vec::new();
        
        fn dfs(current: i32, n: i32, result: &mut Vec<i32>) {
            if current > n {
                return;
            }
            result.push(current);
            
            // 尝试在当前数字后面添加0-9
            for i in 0..=9 {
                let next = current * 10 + i;
                if next > n {
                    break;
                }
                dfs(next, n, result);
            }
        }
        
        // 从1-9开始，按字典序遍历
        for i in 1..=9 {
            if i > n {
                break;
            }
            dfs(i, n, &mut result);
        }
        
        result
    }
}
```

[题解则是循环版本的dfs](https://leetcode.cn/problems/lexicographical-numbers/solutions/1428281/zi-dian-xu-pai-shu-by-leetcode-solution-98mz/)

```cpp
class Solution {
public:
    vector<int> lexicalOrder(int n) {
        vector<int> ret(n);
        int number = 1;
        for (int i = 0; i < n; i++) {
            ret[i] = number;
            if (number * 10 <= n) {
                number *= 10;
            } else {
                while (number % 10 == 9 || number + 1 > n) {
                    number /= 10;
                }
                number++;
            }
        }
        return ret;
    }
};
```

## Review
Scale or Die at Accelerate 2025: Introducing Alpenglow - Solana’s New Consensus

<iframe width="560" height="315" src="https://www.youtube.com/embed/x1sxtm-dvyE?si=u-PLFU2Mww04AH5L" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" referrerpolicy="strict-origin-when-cross-origin" allowfullscreen></iframe>

## Tips
[Alpenglow 是什么？Solana 正在悄悄引爆下一场性能革命](https://mp.weixin.qq.com/s?__biz=MzU4Mjk1MTI2NA==&mid=2247515323&idx=2&sn=3805b947251c2366874504fa91268f5f&poc_token=HGxaRWij97aKYZj1Rzrvq8ptK37x_JREqD1gdJDm)

> ### 投票费的终结和 Solana 的新经济模式？
> Alpenglow 的诸多影响中，对 Solana 生态系统影响最大的一项就是取消了“投票费”。到目前为止，Solana 上的每个区块都要求验证者提交投票交易，以确认他们参与了共识。
> 
> 这些验证者投票交易代表着巨大的运营成本，特别是对于较小的验证者而言——每天高达 1.1 SOL，或每年超过 400 SOL，才有资格投票。
> 
> 这也是 Solana 验证者门槛如此之高的主要原因之一。预计盈亏平衡门槛约为 4,850 SOL，约合 825,000 美元。
> 
> Alpenglow 取消了这种投票费用机制。投票现在通过聚合 BLS 签名[20]进行处理，并原生集成到协议层。换句话说，验证者不再需要为每个区块提交投票交易。
> 
> 根据初步估计[21]，这一变化预计将使验证者的运营成本降低约 80% 。实际上，运行验证者的盈亏平衡门槛可能会从 4,850 SOL 降至 450 SOL 左右，从而使更多独立验证者加入网络在经济上变得可行。
> 
> 更重要的是，这一变化从根本上改变了 Solana 上验证者运营的经济模式。此前，小型验证者严重依赖 SOL 通胀及其相关奖励来弥补其成本，尤其是投票费。取消这些费用可以减少对通胀的依赖，并提高网络的长期可持续性。
> 
> 它还可能重启 Solana 团队最近探讨的提案。2025年3月，旨在降低 SOL 通胀率的提案 SIMD-228[22] 被否决。虽然大多数大型验证者投了赞成票，但小型验证者却表示反对，因为他们担心自己的盈利能力会受到严重影响。
> 
> ### 总结
> Solana 正在通过 Alpenglow 对其共识机制进行全面重新设计。简而言之，其目标有两个：大幅提升性能并简化协议架构。
> 
> 简而言之，最显著的改进是将区块最终确定时间从大约 12 秒减少到 250 毫秒以下，中位数约为 150 毫秒 —— 根据 Anza 的内部模拟，在最佳情况下，性能为 100 毫秒。
> 
> 这意味着 Solana 除了成为延迟最低的区块链之外，现在还可以与顶级 Web2 基础设施相媲美。它为金融、游戏等领域需要近乎即时最终性的全新应用浪潮打开了大门。
> 
> 最终，Alpenglow 的真正突破在于，Solana 不仅定位为一个快速的区块链，而且定位为一个可以与 Web2 标准竞争且不损害去中心化或安全性的平台。

## Share
[solana-amm最小代码实现](https://github.com/wolfdan666/solar-developers-open-course-amm)

